Index: trunk/source/geometry/solids/CSG/src/G4Sphere.cc
===================================================================
--- trunk/source/geometry/solids/CSG/src/G4Sphere.cc	(revision 1227)
+++ trunk/source/geometry/solids/CSG/src/G4Sphere.cc	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4Sphere.cc,v 1.68 2008/07/07 09:35:16 grichine Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4Sphere.cc,v 1.84 2009/08/07 15:56:23 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4Sphere
@@ -34,4 +34,6 @@
 // History:
 //
+// 14.09.09 T.Nikitina: fix for phi section in DistanceToOut(p,v,..),as for G4Tubs,G4Cons 
+// 26.03.09 G.Cosmo   : optimisations and uniform use of local radial tolerance
 // 12.06.08 V.Grichine: fix for theta intersections in DistanceToOut(p,v,...)
 // 22.07.05 O.Link    : Added check for intersection with double cone
@@ -41,5 +43,5 @@
 // 02.06.04 V.Grichine: bug fixed in DistanceToIn(p,v), on Rmax,Rmin go inside
 // 30.10.03 J.Apostolakis: new algorithm in Inside for SPhi-sections
-// 29.10.03 J.Apostolakis: fix in Inside for SPhi-0.5*kAngTol < phi < SPhi, SPhi<0
+// 29.10.03 J.Apostolakis: fix in Inside for SPhi-0.5*kAngTol < phi<SPhi, SPhi<0
 // 19.06.02 V.Grichine: bug fixed in Inside(p), && -> && fDTheta - kAngTolerance
 // 30.01.02 V.Grichine: bug fixed in Inside(p), && -> || at l.451
@@ -53,6 +55,4 @@
 // --------------------------------------------------------------------
 
-#include <assert.h>
-
 #include "G4Sphere.hh"
 
@@ -92,16 +92,19 @@
                           G4double pSPhi, G4double pDPhi,
                           G4double pSTheta, G4double pDTheta )
-  : G4CSGSolid(pName)
+  : G4CSGSolid(pName), fFullPhiSphere(true), fFullThetaSphere(true)
 {
-  fEpsilon = 1.0e-14;
-
-  kRadTolerance = G4GeometryTolerance::GetInstance()->GetRadialTolerance();
+  fEpsilon = 2.0e-11;  // relative radial tolerance constant
+
   kAngTolerance = G4GeometryTolerance::GetInstance()->GetAngularTolerance();
 
-  // Check radii
-
-  if (pRmin<pRmax&&pRmin>=0)
+  // Check radii and set radial tolerances
+
+  G4double kRadTolerance = G4GeometryTolerance::GetInstance()
+                         ->GetRadialTolerance();
+  if ( (pRmin < pRmax) && (pRmax >= 10*kRadTolerance) && (pRmin >= 0) )
   {
     fRmin=pRmin; fRmax=pRmax;
+    fRminTolerance = (pRmin) ? std::max( kRadTolerance, fEpsilon*fRmin ) : 0;
+    fRmaxTolerance = std::max( kRadTolerance, fEpsilon*fRmax );
   }
   else
@@ -116,66 +119,6 @@
   // Check angles
 
-  if (pDPhi>=twopi)
-  {
-    fDPhi=twopi;
-  }
-  else if (pDPhi>0)
-  {
-    fDPhi=pDPhi;
-  }
-  else
-  {
-    G4cerr << "ERROR - G4Sphere()::G4Sphere(): " << GetName() << G4endl
-           << "        Negative Z delta-Phi ! - "
-           << pDPhi << G4endl;
-    G4Exception("G4Sphere::G4Sphere()", "InvalidSetup", FatalException,
-                "Invalid DPhi.");
-  }
-
-  // Convert fSPhi to 0-2PI
-
-  if (pSPhi<0)
-  {
-    fSPhi=twopi-std::fmod(std::fabs(pSPhi),twopi);
-  }
-  else
-  {
-    fSPhi=std::fmod(pSPhi,twopi);
-  }
-
-  // Sphere is placed such that fSPhi+fDPhi>twopi !
-  // fSPhi could be < 0 !!?
-  //
-  if (fSPhi+fDPhi>twopi) fSPhi-=twopi;
-
-  // Check theta angles
-
-  if (pSTheta<0 || pSTheta>pi)
-  {
-    G4cerr << "ERROR - G4Sphere()::G4Sphere(): " << GetName() << G4endl;
-    G4Exception("G4Sphere::G4Sphere()", "InvalidSetup", FatalException,
-                "stheta outside 0-PI range.");
-  }
-  else
-  {
-    fSTheta=pSTheta;
-  }
-
-  if (pDTheta+pSTheta>=pi)
-  {
-    fDTheta=pi-pSTheta;
-  }
-  else if (pDTheta>0)
-  {
-    fDTheta=pDTheta;
-  }
-  else
-  {
-    G4cerr << "ERROR - G4Sphere()::G4Sphere(): " << GetName() << G4endl
-           << "        Negative delta-Theta ! - "
-           << pDTheta << G4endl;
-    G4Exception("G4Sphere::G4Sphere()", "InvalidSetup", FatalException,
-                "Invalid pDTheta.");
-  }
+  CheckPhiAngles(pSPhi, pDPhi);
+  CheckThetaAngles(pSTheta, pDTheta);
 }
 
@@ -219,5 +162,5 @@
                                         G4double& pMin, G4double& pMax ) const
 {
-  if ( fDPhi==twopi && fDTheta==pi)  // !pTransform.IsRotated() &&
+  if ( fFullSphere )
   {
     // Special case handling for solid spheres-shells
@@ -310,5 +253,5 @@
         yoff1=yoffset-yMin;
         yoff2=yMax-yoffset;
-        if (yoff1>=0&&yoff2>=0)
+        if ((yoff1>=0) && (yoff2>=0))
         {
           // Y limits cross max/min x => no change
@@ -334,5 +277,5 @@
         xoff1=xoffset-xMin;
         xoff2=xMax-xoffset;
-        if (xoff1>=0&&xoff2>=0)
+        if ((xoff1>=0) && (xoff2>=0))
         {
           // X limits cross max/min y => no change
@@ -416,5 +359,5 @@
     }
       
-    if (pMin!=kInfinity || pMax!=-kInfinity)
+    if ((pMin!=kInfinity) || (pMax!=-kInfinity))
     {
       existsAfterClip=true;
@@ -453,5 +396,5 @@
 // Return whether point inside/outside/on surface
 // Split into radius, phi, theta checks
-// Each check modifies `in', or returns as approprate
+// Each check modifies 'in', or returns as approprate
 
 EInside G4Sphere::Inside( const G4ThreeVector& p ) const
@@ -459,68 +402,59 @@
   G4double rho,rho2,rad2,tolRMin,tolRMax;
   G4double pPhi,pTheta;
-  EInside in=kOutside;
+  EInside in = kOutside;
+  static const G4double halfAngTolerance = kAngTolerance*0.5;
+  const G4double halfRmaxTolerance = fRmaxTolerance*0.5;
+  const G4double halfRminTolerance = fRminTolerance*0.5;
+  const G4double Rmax_minus = fRmax - halfRmaxTolerance;
+  const G4double Rmin_plus  = (fRmin > 0) ? fRmin+halfRminTolerance : 0;
 
   rho2 = p.x()*p.x() + p.y()*p.y() ;
   rad2 = rho2 + p.z()*p.z() ;
 
-  //  if(rad2 >= 1.369e+19) DBG();
-  //  G4double rad = std::sqrt(rad2);
-  // Check radial surfaces
-  // sets `in'
-
-  if ( fRmin ) tolRMin = fRmin + kRadTolerance*0.5;
-  else         tolRMin = 0 ;
-  
-  tolRMax = fRmax - kRadTolerance*0.5 ;
-  //  const G4double  fractionTolerance = 1.0e-12;
-  const G4double  flexRadMaxTolerance = // kRadTolerance;
-    std::max(kRadTolerance, fEpsilon * fRmax);
-
-  const G4double  Rmax_minus = fRmax - flexRadMaxTolerance*0.5;
-  const G4double  flexRadMinTolerance = std::max(kRadTolerance, 
-                     fEpsilon * fRmin);
-  const G4double  Rmin_plus = (fRmin > 0) ? fRmin + flexRadMinTolerance*0.5 : 0 ;
+  // Check radial surfaces. Sets 'in'
+
+  tolRMin = Rmin_plus;
+  tolRMax = Rmax_minus;
+
+  if ( (rad2 <= Rmax_minus*Rmax_minus) && (rad2 >= Rmin_plus*Rmin_plus) )
+  {
+    in = kInside;
+  }
+  else
+  {
+    tolRMax = fRmax + halfRmaxTolerance;                  // outside case
+    tolRMin = std::max(fRmin-halfRminTolerance, 0.);      // outside case
+    if ( (rad2 <= tolRMax*tolRMax) && (rad2 >= tolRMin*tolRMin) )
+    {
+      in = kSurface;
+    }
+    else
+    {
+      return in = kOutside;
+    }
+  }
+
+  // Phi boundaries   : Do not check if it has no phi boundary!
+
+  if ( !fFullPhiSphere && rho2 )  // [fDPhi < twopi] and [p.x or p.y]
+  {
+    pPhi = std::atan2(p.y(),p.x()) ;
+
+    if      ( pPhi < fSPhi - halfAngTolerance  ) { pPhi += twopi; }
+    else if ( pPhi > ePhi + halfAngTolerance )   { pPhi -= twopi; }
     
-if(rad2 <= Rmax_minus*Rmax_minus && rad2 >= Rmin_plus*Rmin_plus) in = kInside ; 
-
-// if ( rad2 <= tolRMax*tolRMax && rad2 >= tolRMin*tolRMin )  in = kInside ;
-  // if ( rad <= tolRMax && rad >= tolRMin )  in = kInside ;
-  else
-  {
-    tolRMax = fRmax + kRadTolerance*0.5 ;
-    tolRMin = fRmin - kRadTolerance*0.5 ;
-
-    if ( tolRMin < 0.0 ) tolRMin = 0.0 ;
-    
-     if ( rad2 <= tolRMax*tolRMax && rad2 >= tolRMin*tolRMin )  in = kSurface ;
-    //  if ( rad <= tolRMax && rad >= tolRMin )  in = kSurface ;
-    else                                                return in = kOutside ;
-  }
-
-  // Phi boundaries   : Do not check if it has no phi boundary!
-  // (in != kOutside). It is new J.Apostolakis proposal of 30.10.03
-
-  if ( ( fDPhi < twopi - kAngTolerance ) &&
-       ( (p.x() != 0.0 ) || (p.y() != 0.0) ) )
-  {
-    pPhi = std::atan2(p.y(),p.x()) ;
-
-    if      ( pPhi < fSPhi - kAngTolerance*0.5  )         pPhi += twopi ; 
-    else if ( pPhi > fSPhi + fDPhi + kAngTolerance*0.5 )  pPhi -= twopi; 
-    
-    if ((pPhi < fSPhi - kAngTolerance*0.5) ||  
-        (pPhi > fSPhi + fDPhi + kAngTolerance*0.5) )  return in = kOutside ;
+    if ( (pPhi < fSPhi - halfAngTolerance)
+      || (pPhi > ePhi + halfAngTolerance) )      { return in = kOutside; }
     
     else if (in == kInside)  // else it's kSurface anyway already
     {
-      if ( (pPhi < fSPhi + kAngTolerance*0.5) || 
-           (pPhi > fSPhi + fDPhi - kAngTolerance*0.5) )      in = kSurface ;       
+      if ( (pPhi < fSPhi + halfAngTolerance)
+        || (pPhi > ePhi - halfAngTolerance) )    { in = kSurface; }     
     }
   }
 
   // Theta bondaries
-  // (in!=kOutside)
   
-  if ( (rho2 || p.z()) && fDTheta < pi - kAngTolerance*0.5 )
+  if ( (rho2 || p.z()) && (!fFullThetaSphere) )
   {
     rho    = std::sqrt(rho2);
@@ -529,15 +463,15 @@
     if ( in == kInside )
     {
-      if ( (pTheta < fSTheta + kAngTolerance*0.5)
-        || (pTheta > fSTheta + fDTheta - kAngTolerance*0.5) )
-      {
-        if ( (pTheta >= fSTheta - kAngTolerance*0.5)
-          && (pTheta <= fSTheta + fDTheta + kAngTolerance*0.5) )
-        {
-          in = kSurface ;
+      if ( (pTheta < fSTheta + halfAngTolerance)
+        || (pTheta > eTheta - halfAngTolerance) )
+      {
+        if ( (pTheta >= fSTheta - halfAngTolerance)
+          && (pTheta <= eTheta + halfAngTolerance) )
+        {
+          in = kSurface;
         }
         else
         {
-          in = kOutside ;
+          in = kOutside;
         }
       }
@@ -545,8 +479,8 @@
     else
     {
-      if ( (pTheta < fSTheta - kAngTolerance*0.5)
-        || (pTheta > fSTheta + fDTheta + kAngTolerance*0.5) )
-      {
-        in = kOutside ;
+      if ( (pTheta < fSTheta - halfAngTolerance)
+        || (pTheta > eTheta + halfAngTolerance) )
+      {
+        in = kOutside;
       }
     }
@@ -568,7 +502,9 @@
   G4double distSPhi = kInfinity, distEPhi = kInfinity;
   G4double distSTheta = kInfinity, distETheta = kInfinity;
-  G4double delta = 0.5*kCarTolerance, dAngle = 0.5*kAngTolerance;
   G4ThreeVector nR, nPs, nPe, nTs, nTe, nZ(0.,0.,1.);
   G4ThreeVector norm, sumnorm(0.,0.,0.);
+
+  static const G4double halfCarTolerance = 0.5*kCarTolerance;
+  static const G4double halfAngTolerance = 0.5*kAngTolerance;
 
   rho2 = p.x()*p.x()+p.y()*p.y();
@@ -579,17 +515,17 @@
   if (fRmin)  distRMin = std::fabs(rad-fRmin);
     
-  if ( rho && (fDPhi < twopi || fDTheta < pi) )
+  if ( rho && !fFullSphere )
   {
     pPhi = std::atan2(p.y(),p.x());
 
-    if(pPhi  < fSPhi-dAngle)           pPhi     += twopi;
-    else if(pPhi > fSPhi+fDPhi+dAngle) pPhi     -= twopi;
-  }
-  if ( fDPhi < twopi ) // && rho ) // old limitation against (0,0,z)
+    if (pPhi < fSPhi-halfAngTolerance)     { pPhi += twopi; }
+    else if (pPhi > ePhi+halfAngTolerance) { pPhi -= twopi; }
+  }
+  if ( !fFullPhiSphere )
   {
     if ( rho )
     {
-      distSPhi = std::fabs( pPhi - fSPhi ); 
-      distEPhi = std::fabs(pPhi-fSPhi-fDPhi); 
+      distSPhi = std::fabs( pPhi-fSPhi ); 
+      distEPhi = std::fabs( pPhi-ePhi ); 
     }
     else if( !fRmin )
@@ -598,8 +534,8 @@
       distEPhi = 0.; 
     }
-    nPs = G4ThreeVector(std::sin(fSPhi),-std::cos(fSPhi),0);
-    nPe = G4ThreeVector(-std::sin(fSPhi+fDPhi),std::cos(fSPhi+fDPhi),0);
+    nPs = G4ThreeVector(sinSPhi,-cosSPhi,0);
+    nPe = G4ThreeVector(-sinEPhi,cosEPhi,0);
   }        
-  if ( fDTheta < pi ) // && rad ) // old limitation against (0,0,0)
+  if ( !fFullThetaSphere )
   {
     if ( rho )
@@ -607,13 +543,13 @@
       pTheta     = std::atan2(rho,p.z());
       distSTheta = std::fabs(pTheta-fSTheta); 
-      distETheta = std::fabs(pTheta-fSTheta-fDTheta);
+      distETheta = std::fabs(pTheta-eTheta);
  
-      nTs = G4ThreeVector(-std::cos(fSTheta)*p.x()/rho, //  *std::cos(pPhi),
-                          -std::cos(fSTheta)*p.y()/rho, //  *std::sin(pPhi),
-                           std::sin(fSTheta)                   );
-
-      nTe = G4ThreeVector( std::cos(fSTheta+fDTheta)*p.x()/rho, // *std::cos(pPhi),
-                           std::cos(fSTheta+fDTheta)*p.y()/rho, // *std::sin(pPhi),
-                          -std::sin(fSTheta+fDTheta)                  );    
+      nTs = G4ThreeVector(-cosSTheta*p.x()/rho,
+                          -cosSTheta*p.y()/rho,
+                           sinSTheta          );
+
+      nTe = G4ThreeVector( cosETheta*p.x()/rho,
+                           cosETheta*p.y()/rho,
+                          -sinETheta          );    
     }
     else if( !fRmin )
@@ -622,33 +558,33 @@
       {              
         distSTheta = 0.;
-	nTs = G4ThreeVector(0.,0.,-1.);
-      }
-      if ( fSTheta + fDTheta < pi ) // distETheta = 0.;
+        nTs = G4ThreeVector(0.,0.,-1.);
+      }
+      if ( eTheta < pi )
       {              
         distETheta = 0.;
-	nTe = G4ThreeVector(0.,0.,1.);
+        nTe = G4ThreeVector(0.,0.,1.);
       }
     }    
   }
-  if( rad )  nR = G4ThreeVector(p.x()/rad,p.y()/rad,p.z()/rad);
-
-  if( distRMax <= delta )
+  if( rad )  { nR = G4ThreeVector(p.x()/rad,p.y()/rad,p.z()/rad); }
+
+  if( distRMax <= halfCarTolerance )
   {
     noSurfaces ++;
     sumnorm += nR;
   }
-  if( fRmin && distRMin <= delta )
+  if( fRmin && (distRMin <= halfCarTolerance) )
   {
     noSurfaces ++;
     sumnorm -= nR;
   }
-  if( fDPhi < twopi )   
-  {
-    if (distSPhi <= dAngle)
+  if( !fFullPhiSphere )   
+  {
+    if (distSPhi <= halfAngTolerance)
     {
       noSurfaces ++;
       sumnorm += nPs;
     }
-    if (distEPhi <= dAngle) 
+    if (distEPhi <= halfAngTolerance) 
     {
       noSurfaces ++;
@@ -656,18 +592,18 @@
     }
   }
-  if ( fDTheta < pi )
-  {
-    if (distSTheta <= dAngle && fSTheta > 0.)
+  if ( !fFullThetaSphere )
+  {
+    if ((distSTheta <= halfAngTolerance) && (fSTheta > 0.))
     {
       noSurfaces ++;
-      if( rad <= delta && fDPhi >= twopi) sumnorm += nZ;
-      else                                sumnorm += nTs;
-    }
-    if (distETheta <= dAngle && fSTheta+fDTheta < pi) 
+      if ((rad <= halfCarTolerance) && fFullPhiSphere)  { sumnorm += nZ;  }
+      else                                              { sumnorm += nTs; }
+    }
+    if ((distETheta <= halfAngTolerance) && (eTheta < pi)) 
     {
       noSurfaces ++;
-      if( rad <= delta && fDPhi >= twopi) sumnorm -= nZ;
-      else                                sumnorm += nTe;
-      if(sumnorm.z() == 0.)               sumnorm += nZ;
+      if ((rad <= halfCarTolerance) && fFullPhiSphere)  { sumnorm -= nZ;  }
+      else                                              { sumnorm += nTe; }
+      if(sumnorm.z() == 0.)  { sumnorm += nZ; }
     }
   }
@@ -680,6 +616,6 @@
      norm = ApproxSurfaceNormal(p);
   }
-  else if ( noSurfaces == 1 ) norm = sumnorm;
-  else                        norm = sumnorm.unit();
+  else if ( noSurfaces == 1 )  { norm = sumnorm; }
+  else                         { norm = sumnorm.unit(); }
   return norm;
 }
@@ -735,7 +671,7 @@
     
   pPhi = std::atan2(p.y(),p.x());
-  if (pPhi<0) pPhi += twopi;
-
-  if (fDPhi<twopi&&rho)
+  if (pPhi<0) { pPhi += twopi; }
+
+  if (!fFullPhiSphere && rho)
   {
     if (fSPhi<0)
@@ -774,5 +710,5 @@
   //
 
-  if (fDTheta<pi&&rad)
+  if (!fFullThetaSphere && rad)
   {
     pTheta=std::atan2(rho,p.z());
@@ -809,38 +745,25 @@
       break;
     case kNSPhi:
-      norm=G4ThreeVector(std::sin(fSPhi),-std::cos(fSPhi),0);
+      norm=G4ThreeVector(sinSPhi,-cosSPhi,0);
       break;
     case kNEPhi:
-      norm=G4ThreeVector(-std::sin(fSPhi+fDPhi),std::cos(fSPhi+fDPhi),0);
+      norm=G4ThreeVector(-sinEPhi,cosEPhi,0);
       break;
     case kNSTheta:
-      norm=G4ThreeVector(-std::cos(fSTheta)*std::cos(pPhi),
-                         -std::cos(fSTheta)*std::sin(pPhi),
-                          std::sin(fSTheta)            );
-      //  G4cout<<G4endl<<" case kNSTheta:"<<G4endl;
-      //  G4cout<<"pPhi = "<<pPhi<<G4endl;
-      //  G4cout<<"rad  = "<<rad<<G4endl;
-      //  G4cout<<"pho  = "<<rho<<G4endl;
-      //  G4cout<<"p:    "<<p.x()<<"; "<<p.y()<<"; "<<p.z()<<G4endl;
-      //  G4cout<<"norm: "<<norm.x()<<"; "<<norm.y()<<"; "<<norm.z()<<G4endl;
+      norm=G4ThreeVector(-cosSTheta*std::cos(pPhi),
+                         -cosSTheta*std::sin(pPhi),
+                          sinSTheta            );
       break;
     case kNETheta:
-      norm=G4ThreeVector( std::cos(fSTheta+fDTheta)*std::cos(pPhi),
-                          std::cos(fSTheta+fDTheta)*std::sin(pPhi),
-                         -std::sin(fSTheta+fDTheta)              );
-
-      //  G4cout<<G4endl<<" case kNETheta:"<<G4endl;
-      //  G4cout<<"pPhi = "<<pPhi<<G4endl;
-      //  G4cout<<"rad  = "<<rad<<G4endl;
-      //  G4cout<<"pho  = "<<rho<<G4endl;
-      //  G4cout<<"p:    "<<p.x()<<"; "<<p.y()<<"; "<<p.z()<<G4endl;
-      //  G4cout<<"norm: "<<norm.x()<<"; "<<norm.y()<<"; "<<norm.z()<<G4endl;
+      norm=G4ThreeVector( cosETheta*std::cos(pPhi),
+                          cosETheta*std::sin(pPhi),
+                         -sinETheta              );
       break;
     default:
       DumpInfo();
-      G4Exception("G4Sphere::ApproxSurfaceNormal()", "Notification", JustWarning,
+      G4Exception("G4Sphere::ApproxSurfaceNormal()","Notification",JustWarning,
                   "Undefined side for valid surface normal to solid.");
       break;    
-  } // end case
+  }
 
   return norm;
@@ -880,33 +803,40 @@
 {
   G4double snxt = kInfinity ;      // snxt = default return value
-
   G4double rho2, rad2, pDotV2d, pDotV3d, pTheta ;
-
-  G4double tolIRMin2, tolORMin2, tolORMax2, tolIRMax2 ;
   G4double tolSTheta=0., tolETheta=0. ;
+  const G4double dRmax = 100.*fRmax;
+
+  static const G4double halfCarTolerance = kCarTolerance*0.5;
+  static const G4double halfAngTolerance = kAngTolerance*0.5;
+  const G4double halfRmaxTolerance = fRmaxTolerance*0.5;
+  const G4double halfRminTolerance = fRminTolerance*0.5;
+  const G4double tolORMin2 = (fRmin>halfRminTolerance)
+               ? (fRmin-halfRminTolerance)*(fRmin-halfRminTolerance) : 0;
+  const G4double tolIRMin2 =
+               (fRmin+halfRminTolerance)*(fRmin+halfRminTolerance);
+  const G4double tolORMax2 =
+               (fRmax+halfRmaxTolerance)*(fRmax+halfRmaxTolerance);
+  const G4double tolIRMax2 =
+               (fRmax-halfRmaxTolerance)*(fRmax-halfRmaxTolerance);
 
   // Intersection point
-
+  //
   G4double xi, yi, zi, rhoi, rhoi2, radi2, iTheta ;
 
   // Phi intersection
-
-  G4double sinSPhi, cosSPhi, ePhi, sinEPhi, cosEPhi , Comp ; 
-
-  // Phi flag and precalcs
-
-  G4bool segPhi ;        
-  G4double hDPhi, hDPhiOT, hDPhiIT, cPhi, sinCPhi=0., cosCPhi=0. ; 
-  G4double cosHDPhiOT=0., cosHDPhiIT=0. ;
+  //
+  G4double Comp ; 
+
+  // Phi precalcs
+  //
   G4double Dist, cosPsi ;
 
-  G4bool segTheta ;                             // Theta flag and precals
-  G4double tanSTheta, tanETheta ;
-  G4double tanSTheta2, tanETheta2 ;
+  // Theta precalcs
+  //
   G4double dist2STheta, dist2ETheta ;
   G4double t1, t2, b, c, d2, d, s = kInfinity ;
 
   // General Precalcs
-
+  //
   rho2 = p.x()*p.x() + p.y()*p.y() ;
   rad2 = rho2 + p.z()*p.z() ;
@@ -916,50 +846,10 @@
   pDotV3d = pDotV2d + p.z()*v.z() ;
 
-  // Radial Precalcs
-
-  if (fRmin > kRadTolerance*0.5)
-  {
-    tolORMin2=(fRmin-kRadTolerance*0.5)*(fRmin-kRadTolerance*0.5);
-  }
-  else
-  {
-    tolORMin2 = 0 ;
-  }
-  tolIRMin2 = (fRmin+kRadTolerance*0.5)*(fRmin+kRadTolerance*0.5) ;
-  tolORMax2 = (fRmax+kRadTolerance*0.5)*(fRmax+kRadTolerance*0.5) ;
-  tolIRMax2 = (fRmax-kRadTolerance*0.5)*(fRmax-kRadTolerance*0.5) ;
-
-  // Set phi divided flag and precalcs
-
-  if (fDPhi < twopi)
-  {
-    segPhi = true ;
-    hDPhi = 0.5*fDPhi ;    // half delta phi
-    cPhi = fSPhi + hDPhi ;
-
-    hDPhiOT = hDPhi+0.5*kAngTolerance; // Outer Tolerant half delta phi 
-    hDPhiIT = hDPhi-0.5*kAngTolerance;
-
-    sinCPhi    = std::sin(cPhi) ;
-    cosCPhi    = std::cos(cPhi) ;
-    cosHDPhiOT = std::cos(hDPhiOT) ;
-    cosHDPhiIT = std::cos(hDPhiIT) ;
-  }
-  else
-  {
-    segPhi = false ;
-  }
-
   // Theta precalcs
-    
-  if (fDTheta < pi )
-  {
-    segTheta  = true ;
-    tolSTheta = fSTheta - kAngTolerance*0.5 ;
-    tolETheta = fSTheta + fDTheta + kAngTolerance*0.5 ;
-  }
-  else
-  {
-    segTheta = false ;
+  //
+  if (!fFullThetaSphere)
+  {
+    tolSTheta = fSTheta - halfAngTolerance ;
+    tolETheta = eTheta + halfAngTolerance ;
   }
 
@@ -979,12 +869,9 @@
 
   c = rad2 - fRmax*fRmax ;
-  const G4double  flexRadMaxTolerance = // kRadTolerance;
-    std::max(kRadTolerance, fEpsilon * fRmax);
-
-  //  if (c > kRadTolerance*fRmax)
-  if (c > flexRadMaxTolerance*fRmax)
-  {
-    // If outside toleranct boundary of outer G4Sphere
-    // [should be std::sqrt(rad2)-fRmax > kRadTolerance*0.5]
+
+  if (c > fRmaxTolerance*fRmax)
+  {
+    // If outside tolerant boundary of outer G4Sphere
+    // [should be std::sqrt(rad2)-fRmax > halfRmaxTolerance]
 
     d2 = pDotV3d*pDotV3d - c ;
@@ -996,9 +883,14 @@
       if (s >= 0 )
       {
+        if ( s>dRmax ) // Avoid rounding errors due to precision issues seen on
+        {              // 64 bits systems. Split long distances and recompute
+          G4double fTerm = s-std::fmod(s,dRmax);
+          s = fTerm + DistanceToIn(p+fTerm*v,v);
+        } 
         xi   = p.x() + s*v.x() ;
         yi   = p.y() + s*v.y() ;
         rhoi = std::sqrt(xi*xi + yi*yi) ;
 
-        if (segPhi && rhoi)    // Check phi intersection
+        if (!fFullPhiSphere && rhoi)    // Check phi intersection
         {
           cosPsi = (xi*cosCPhi + yi*sinCPhi)/rhoi ;
@@ -1006,5 +898,5 @@
           if (cosPsi >= cosHDPhiOT)
           {
-            if (segTheta)   // Check theta intersection
+            if (!fFullThetaSphere)   // Check theta intersection
             {
               zi = p.z() + s*v.z() ;
@@ -1027,5 +919,5 @@
         else
         {
-          if (segTheta)    // Check theta intersection
+          if (!fFullThetaSphere)    // Check theta intersection
           {
             zi = p.z() + s*v.z() ;
@@ -1059,9 +951,8 @@
     d2 = pDotV3d*pDotV3d - c ;
 
-    // if (rad2 > tolIRMin2 && pDotV3d < 0 )
-
-    if (rad2 > tolIRMax2 && ( d2 >= flexRadMaxTolerance*fRmax && pDotV3d < 0 ) )
-    {
-      if (segPhi)
+    if ( (rad2 > tolIRMax2)
+      && ( (d2 >= fRmaxTolerance*fRmax) && (pDotV3d < 0) ) )
+    {
+      if (!fFullPhiSphere)
       {
         // Use inner phi tolerant boundary -> if on tolerant
@@ -1074,5 +965,5 @@
           // inside radii, delta r -ve, inside phi
 
-          if (segTheta)
+          if ( !fFullThetaSphere )
           {
             if ( (pTheta >= tolSTheta + kAngTolerance)
@@ -1090,5 +981,5 @@
       else
       {
-        if ( segTheta )
+        if ( !fFullThetaSphere )
         {
           if ( (pTheta >= tolSTheta + kAngTolerance)
@@ -1109,5 +1000,5 @@
   // - Always farthest root, because would have passed through outer
   //   surface first.
-  // - Tolerant check for if travelling through solid
+  // - Tolerant check if travelling through solid
 
   if (fRmin)
@@ -1119,10 +1010,8 @@
     // Check for immediate entry/already inside and travelling outwards
 
-    // if (c >- kRadTolerance*0.5 && pDotV3d >= 0 && rad2 < tolIRMin2 )
-
-    if ( c > -kRadTolerance*0.5 && rad2 < tolIRMin2 && 
-         ( d2 < fRmin*kCarTolerance || pDotV3d >= 0 ) )
-    {
-      if (segPhi)
+    if ( (c > -halfRminTolerance) && (rad2 < tolIRMin2)
+      && ( (d2 < fRmin*kCarTolerance) || (pDotV3d >= 0) ) )
+    {
+      if ( !fFullPhiSphere )
       {
         // Use inner phi tolerant boundary -> if on tolerant
@@ -1134,5 +1023,5 @@
           // inside radii, delta r -ve, inside phi
           //
-          if (segTheta)
+          if ( !fFullThetaSphere )
           {
             if ( (pTheta >= tolSTheta + kAngTolerance)
@@ -1150,5 +1039,5 @@
       else
       {
-        if (segTheta)
+        if ( !fFullThetaSphere )
         {
           if ( (pTheta >= tolSTheta + kAngTolerance)
@@ -1166,10 +1055,8 @@
     else   // Not special tolerant case
     {
-      //  d2 = pDotV3d*pDotV3d - c ;
-
       if (d2 >= 0)
       {
         s = -pDotV3d + std::sqrt(d2) ;
-        if ( s >= kRadTolerance*0.5 )  // It was >= 0 ??
+        if ( s >= halfRminTolerance )  // It was >= 0 ??
         {
           xi   = p.x() + s*v.x() ;
@@ -1177,5 +1064,5 @@
           rhoi = std::sqrt(xi*xi+yi*yi) ;
 
-          if ( segPhi && rhoi )   // Check phi intersection
+          if ( !fFullPhiSphere && rhoi )   // Check phi intersection
           {
             cosPsi = (xi*cosCPhi + yi*sinCPhi)/rhoi ;
@@ -1183,5 +1070,5 @@
             if (cosPsi >= cosHDPhiOT)
             {
-              if (segTheta)  // Check theta intersection
+              if ( !fFullThetaSphere )  // Check theta intersection
               {
                 zi = p.z() + s*v.z() ;
@@ -1204,5 +1091,5 @@
           else
           {
-            if (segTheta)   // Check theta intersection
+            if ( !fFullThetaSphere )   // Check theta intersection
             {
               zi = p.z() + s*v.z() ;
@@ -1214,10 +1101,10 @@
               if ( (iTheta >= tolSTheta) && (iTheta <= tolETheta) )
               {
-                snxt = s ;
+                snxt = s;
               }
             }
             else
             {
-              snxt=s;
+              snxt = s;
             }
           }
@@ -1236,14 +1123,10 @@
   //         -> Should use some form of loop Construct
   //
-  if ( segPhi )
-  {
-    // First phi surface (`S'tarting phi)
-
-    sinSPhi = std::sin(fSPhi) ;
-    cosSPhi = std::cos(fSPhi) ;
-
+  if ( !fFullPhiSphere )
+  {
+    // First phi surface ('S'tarting phi)
     // Comp = Component in outwards normal dirn
     //
-    Comp    = v.x()*sinSPhi - v.y()*cosSPhi  ;
+    Comp = v.x()*sinSPhi - v.y()*cosSPhi ;
                     
     if ( Comp < 0 )
@@ -1251,5 +1134,5 @@
       Dist = p.y()*cosSPhi - p.x()*sinSPhi ;
 
-      if (Dist < kCarTolerance*0.5)
+      if (Dist < halfCarTolerance)
       {
         s = Dist/Comp ;
@@ -1282,5 +1165,5 @@
             // (=>intersect at origin =>fRmax=0)
             //
-            if ( segTheta )
+            if ( !fFullThetaSphere )
             {
               iTheta = std::atan2(std::sqrt(rhoi2),zi) ;
@@ -1305,18 +1188,13 @@
     }
 
-    // Second phi surface (`E'nding phi)
-
-    ePhi    = fSPhi + fDPhi ;
-    sinEPhi = std::sin(ePhi)     ;
-    cosEPhi = std::cos(ePhi)     ;
-
-    // Compnent in outwards normal dirn
-
-    Comp    = -( v.x()*sinEPhi-v.y()*cosEPhi ) ;
+    // Second phi surface ('E'nding phi)
+    // Component in outwards normal dirn
+
+    Comp = -( v.x()*sinEPhi-v.y()*cosEPhi ) ;
         
     if (Comp < 0)
     {
       Dist = -(p.y()*cosEPhi-p.x()*sinEPhi) ;
-      if ( Dist < kCarTolerance*0.5 )
+      if ( Dist < halfCarTolerance )
       {
         s = Dist/Comp ;
@@ -1340,5 +1218,6 @@
             rhoi2 = rho2  ;
             radi2 = rad2  ;
-          } if ( (radi2 <= tolORMax2)
+          }
+          if ( (radi2 <= tolORMax2)
             && (radi2 >= tolORMin2)
             && ((yi*cosCPhi-xi*sinCPhi) >= 0) )
@@ -1348,5 +1227,5 @@
             // (=>intersect at origin =>fRmax=0)
             //
-            if ( segTheta )
+            if ( !fFullThetaSphere )
             {
               iTheta = std::atan2(std::sqrt(rhoi2),zi) ;
@@ -1374,5 +1253,5 @@
   // Theta segment intersection
 
-  if ( segTheta )
+  if ( !fFullThetaSphere )
   {
 
@@ -1396,9 +1275,4 @@
     // => s^2(1-vz^2(1+tan^2(t))+2s(pdotv2d-pzvztan^2(t))+(rho2-pz^2tan^2(t))=0
 
-    tanSTheta  = std::tan(fSTheta)         ;
-    tanSTheta2 = tanSTheta*tanSTheta  ;
-    tanETheta  = std::tan(fSTheta+fDTheta) ;
-    tanETheta2 = tanETheta*tanETheta  ;
-      
     if (fSTheta)
     {
@@ -1409,13 +1283,13 @@
       dist2STheta = kInfinity ;
     }
-    if ( fSTheta + fDTheta < pi )
+    if ( eTheta < pi )
     {
       dist2ETheta=rho2-p.z()*p.z()*tanETheta2;
     }
-      else
+    else
     {
       dist2ETheta=kInfinity;
     }      
-    if ( pTheta < tolSTheta) // dist2STheta<-kRadTolerance*0.5 && dist2ETheta>0)
+    if ( pTheta < tolSTheta )
     {
       // Inside (theta<stheta-tol) s theta cone
@@ -1424,41 +1298,43 @@
       t1 = 1 - v.z()*v.z()*(1 + tanSTheta2) ;
       t2 = pDotV2d - p.z()*v.z()*tanSTheta2 ;
-        
-      b  = t2/t1 ;
-      c  = dist2STheta/t1 ;
-      d2 = b*b - c ;
-
-      if ( d2 >= 0 )
-      {
-        d = std::sqrt(d2) ;
-        s = -b - d ;    // First root
-        zi    = p.z() + s*v.z();
-
-        if ( s < 0 || zi*(fSTheta - halfpi) > 0 )
-        {
-          s = -b+d;    // Second root
-        }
-        if (s >= 0 && s < snxt)
-        {
-          xi    = p.x() + s*v.x();
-          yi    = p.y() + s*v.y();
+      if (t1)
+      {   
+        b  = t2/t1 ;
+        c  = dist2STheta/t1 ;
+        d2 = b*b - c ;
+
+        if ( d2 >= 0 )
+        {
+          d = std::sqrt(d2) ;
+          s = -b - d ;    // First root
           zi    = p.z() + s*v.z();
-          rhoi2 = xi*xi + yi*yi;
-          radi2 = rhoi2 + zi*zi;
-          if ( (radi2 <= tolORMax2)
-            && (radi2 >= tolORMin2)
-            && (zi*(fSTheta - halfpi) <= 0) )
-          {
-            if ( segPhi && rhoi2 )  // Check phi intersection
-            {
-              cosPsi = (xi*cosCPhi + yi*sinCPhi)/std::sqrt(rhoi2) ;
-              if (cosPsi >= cosHDPhiOT)
+
+          if ( (s < 0) || (zi*(fSTheta - halfpi) > 0) )
+          {
+            s = -b+d;    // Second root
+          }
+          if ((s >= 0) && (s < snxt))
+          {
+            xi    = p.x() + s*v.x();
+            yi    = p.y() + s*v.y();
+            zi    = p.z() + s*v.z();
+            rhoi2 = xi*xi + yi*yi;
+            radi2 = rhoi2 + zi*zi;
+            if ( (radi2 <= tolORMax2)
+              && (radi2 >= tolORMin2)
+              && (zi*(fSTheta - halfpi) <= 0) )
+            {
+              if ( !fFullPhiSphere && rhoi2 )  // Check phi intersection
+              {
+                cosPsi = (xi*cosCPhi + yi*sinCPhi)/std::sqrt(rhoi2) ;
+                if (cosPsi >= cosHDPhiOT)
+                {
+                  snxt = s ;
+                }
+              }
+              else
               {
                 snxt = s ;
               }
-            }
-            else
-            {
-              snxt = s ;
             }
           }
